import{s as Wt,o as Yt,n as Kt}from"../chunks/scheduler.9039eef2.js";import{S as Qt,i as Vt,g as o,s as r,u as Y,A as Zt,h as a,f as e,c as s,j as h,v as K,y as f,k as l,o as u,a as n,w as Q,d as V,t as Z,x as tt}from"../chunks/index.b9cfb1df.js";import{T as te}from"../chunks/Tip.b1721f66.js";import{I as _t}from"../chunks/IconCopyLink.84ab4989.js";function ee(et){let c,T='More details for checking supported tasks <a href="https://huggingface.co/docs/optimum-neuron/guides/export_model#selecting-a-task" rel="nofollow">here</a>.';return{c(){c=o("p"),c.innerHTML=T},l(d){c=a(d,"P",{"data-svelte-h":!0}),f(c)!=="svelte-hfkaug"&&(c.innerHTML=T)},m(d,F){n(d,c,F)},p:Kt,d(d){d&&e(c)}}}function ie(et){let c,T,d,F,p,w,j,$,yt,D,Et="Inferentia Exporter",it,C,bt=`You can export a PyTorch model to Neuron with 🤗 Optimum to run inference on AWS <a href="https://aws.amazon.com/ec2/instance-types/inf1/" rel="nofollow">Inferntia 1</a>
and <a href="https://aws.amazon.com/ec2/instance-types/inf2/" rel="nofollow">Inferentia 2</a>.`,nt,m,g,U,E,Tt,O,Pt="Export functions",ot,b,Lt=`There is an export function for each generation of the Inferentia accelerator, <code>export_neuron</code>
for INF1 and <code>export_neuronx</code> on INF2, but you will be able to use directly the export function <code>export</code>, which will select the proper
exporting function according to the environment.`,at,P,Mt=`Besides, you can check if the exported model is valid via <code>validate_model_outputs</code>, which compares
the compiled model’s output on Neuron devices to the PyTorch model’s output on CPU.`,rt,x,k,G,L,$t,z,Nt="Configuration classes for Neuron exports",st,M,At="Exporting a PyTorch model to a Neuron compiled model involves specifying:",lt,N,qt="<li>The input names.</li> <li>The output names.</li> <li>The dummy inputs used to trace the model. This is needed by the Neuron Compiler to record the computational graph and convert it to a TorchScript module.</li> <li>The compilation arguments used to control the trade-off between hardware efficiency (latency, throughput) and accuracy.</li>",ct,A,Ht=`Depending on the choice of model and task, we represent the data above with <em>configuration classes</em>. Each configuration class is associated with
a specific model architecture, and follows the naming convention <code>ArchitectureNameNeuronConfig</code>. For instance, the configuration which specifies the Neuron
export of BERT models is <code>BertNeuronConfig</code>.`,ut,q,St="Since many architectures share similar properties for their Neuron configuration, 🤗 Optimum adopts a 3-level class hierarchy:",ft,H,Rt=`<li>Abstract and generic base classes. These handle all the fundamental features, while being agnostic to the modality (text, image, audio, etc).</li> <li>Middle-end classes. These are aware of the modality, but multiple can exist for the same modality depending on the inputs they support.
They specify which input generators should be used for the dummy inputs, but remain model-agnostic.</li> <li>Model-specific classes like the <code>BertNeuronConfig</code> mentioned above. These are the ones actually used to export models.</li>`,ht,v,_,J,S,Ct,X,Bt="Supported architectures",dt,R,It="<thead><tr><th>Architecture</th> <th>Task</th></tr></thead> <tbody><tr><td>ALBERT</td> <td>feature-extraction, fill-mask, multiple-choice, question-answering, text-classification, token-classification</td></tr> <tr><td>BERT</td> <td>feature-extraction, fill-mask, multiple-choice, question-answering, text-classification, token-classification</td></tr> <tr><td>CamemBERT</td> <td>feature-extraction, fill-mask, multiple-choice, question-answering, text-classification, token-classification</td></tr> <tr><td>ConvBERT</td> <td>feature-extraction, fill-mask, multiple-choice, question-answering, text-classification, token-classification</td></tr> <tr><td>DeBERTa (INF2 only)</td> <td>feature-extraction, fill-mask, multiple-choice, question-answering, text-classification, token-classification</td></tr> <tr><td>DeBERTa-v2 (INF2 only)</td> <td>feature-extraction, fill-mask, multiple-choice, question-answering, text-classification, token-classification</td></tr> <tr><td>DistilBERT</td> <td>feature-extraction, fill-mask, multiple-choice, question-answering, text-classification, token-classification</td></tr> <tr><td>ELECTRA</td> <td>feature-extraction, fill-mask, multiple-choice, question-answering, text-classification, token-classification</td></tr> <tr><td>FlauBERT</td> <td>feature-extraction, fill-mask, multiple-choice, question-answering, text-classification, token-classification</td></tr> <tr><td>GPT2</td> <td>text-generation</td></tr> <tr><td>MobileBERT</td> <td>feature-extraction, fill-mask, multiple-choice, question-answering, text-classification, token-classification</td></tr> <tr><td>MPNet</td> <td>feature-extraction, fill-mask, multiple-choice, question-answering, text-classification, token-classification</td></tr> <tr><td>RoBERTa</td> <td>feature-extraction, fill-mask, multiple-choice, question-answering, text-classification, token-classification</td></tr> <tr><td>RoFormer</td> <td>feature-extraction, fill-mask, multiple-choice, question-answering, text-classification, token-classification</td></tr> <tr><td>XLM</td> <td>feature-extraction, fill-mask, multiple-choice, question-answering, text-classification, token-classification</td></tr> <tr><td>XLM-RoBERTa</td> <td>feature-extraction, fill-mask, multiple-choice, question-answering, text-classification, token-classification</td></tr> <tr><td>Stable Diffusion</td> <td>text-to-image, image-to-image, inpaint</td></tr> <tr><td>Stable Diffusion XL</td> <td>text-to-image</td></tr></tbody>",pt,y,mt,B,Ft="More architectures coming soon, stay tuned! 🚀",xt,W,vt;return $=new _t({}),E=new _t({}),L=new _t({}),S=new _t({}),y=new te({props:{$$slots:{default:[ee]},$$scope:{ctx:et}}}),{c(){c=o("meta"),T=r(),d=o("p"),F=r(),p=o("h1"),w=o("a"),j=o("span"),Y($.$$.fragment),yt=r(),D=o("span"),D.textContent=Et,it=r(),C=o("p"),C.innerHTML=bt,nt=r(),m=o("h2"),g=o("a"),U=o("span"),Y(E.$$.fragment),Tt=r(),O=o("span"),O.textContent=Pt,ot=r(),b=o("p"),b.innerHTML=Lt,at=r(),P=o("p"),P.innerHTML=Mt,rt=r(),x=o("h2"),k=o("a"),G=o("span"),Y(L.$$.fragment),$t=r(),z=o("span"),z.textContent=Nt,st=r(),M=o("p"),M.textContent=At,lt=r(),N=o("ol"),N.innerHTML=qt,ct=r(),A=o("p"),A.innerHTML=Ht,ut=r(),q=o("p"),q.textContent=St,ft=r(),H=o("ol"),H.innerHTML=Rt,ht=r(),v=o("h2"),_=o("a"),J=o("span"),Y(S.$$.fragment),Ct=r(),X=o("span"),X.textContent=Bt,dt=r(),R=o("table"),R.innerHTML=It,pt=r(),Y(y.$$.fragment),mt=r(),B=o("p"),B.textContent=Ft,xt=r(),W=o("p"),this.h()},l(t){const i=Zt("svelte-1phssyn",document.head);c=a(i,"META",{name:!0,content:!0}),i.forEach(e),T=s(t),d=a(t,"P",{}),h(d).forEach(e),F=s(t),p=a(t,"H1",{class:!0});var I=h(p);w=a(I,"A",{id:!0,class:!0,href:!0});var Dt=h(w);j=a(Dt,"SPAN",{});var Ot=h(j);K($.$$.fragment,Ot),Ot.forEach(e),Dt.forEach(e),yt=s(I),D=a(I,"SPAN",{"data-svelte-h":!0}),f(D)!=="svelte-v2l6en"&&(D.textContent=Et),I.forEach(e),it=s(t),C=a(t,"P",{"data-svelte-h":!0}),f(C)!=="svelte-1d09xet"&&(C.innerHTML=bt),nt=s(t),m=a(t,"H2",{class:!0});var wt=h(m);g=a(wt,"A",{id:!0,class:!0,href:!0});var zt=h(g);U=a(zt,"SPAN",{});var Xt=h(U);K(E.$$.fragment,Xt),Xt.forEach(e),zt.forEach(e),Tt=s(wt),O=a(wt,"SPAN",{"data-svelte-h":!0}),f(O)!=="svelte-wx45x4"&&(O.textContent=Pt),wt.forEach(e),ot=s(t),b=a(t,"P",{"data-svelte-h":!0}),f(b)!=="svelte-1nf9chr"&&(b.innerHTML=Lt),at=s(t),P=a(t,"P",{"data-svelte-h":!0}),f(P)!=="svelte-zk3hwe"&&(P.innerHTML=Mt),rt=s(t),x=a(t,"H2",{class:!0});var gt=h(x);k=a(gt,"A",{id:!0,class:!0,href:!0});var jt=h(k);G=a(jt,"SPAN",{});var Ut=h(G);K(L.$$.fragment,Ut),Ut.forEach(e),jt.forEach(e),$t=s(gt),z=a(gt,"SPAN",{"data-svelte-h":!0}),f(z)!=="svelte-12uya2s"&&(z.textContent=Nt),gt.forEach(e),st=s(t),M=a(t,"P",{"data-svelte-h":!0}),f(M)!=="svelte-15gsxx7"&&(M.textContent=At),lt=s(t),N=a(t,"OL",{"data-svelte-h":!0}),f(N)!=="svelte-lhsb7m"&&(N.innerHTML=qt),ct=s(t),A=a(t,"P",{"data-svelte-h":!0}),f(A)!=="svelte-1hhqq53"&&(A.innerHTML=Ht),ut=s(t),q=a(t,"P",{"data-svelte-h":!0}),f(q)!=="svelte-tqmfwt"&&(q.textContent=St),ft=s(t),H=a(t,"OL",{"data-svelte-h":!0}),f(H)!=="svelte-1ea686j"&&(H.innerHTML=Rt),ht=s(t),v=a(t,"H2",{class:!0});var kt=h(v);_=a(kt,"A",{id:!0,class:!0,href:!0});var Gt=h(_);J=a(Gt,"SPAN",{});var Jt=h(J);K(S.$$.fragment,Jt),Jt.forEach(e),Gt.forEach(e),Ct=s(kt),X=a(kt,"SPAN",{"data-svelte-h":!0}),f(X)!=="svelte-72qc51"&&(X.textContent=Bt),kt.forEach(e),dt=s(t),R=a(t,"TABLE",{"data-svelte-h":!0}),f(R)!=="svelte-1v2my2t"&&(R.innerHTML=It),pt=s(t),K(y.$$.fragment,t),mt=s(t),B=a(t,"P",{"data-svelte-h":!0}),f(B)!=="svelte-dm8pu8"&&(B.textContent=Ft),xt=s(t),W=a(t,"P",{}),h(W).forEach(e),this.h()},h(){l(c,"name","hf:doc:metadata"),l(c,"content",JSON.stringify(ne)),l(w,"id","inferentia-exporter"),l(w,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),l(w,"href","#inferentia-exporter"),l(p,"class","relative group"),l(g,"id","export-functions"),l(g,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),l(g,"href","#export-functions"),l(m,"class","relative group"),l(k,"id","configuration-classes-for-neuron-exports"),l(k,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),l(k,"href","#configuration-classes-for-neuron-exports"),l(x,"class","relative group"),l(_,"id","supported-architectures"),l(_,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),l(_,"href","#supported-architectures"),l(v,"class","relative group")},m(t,i){u(document.head,c),n(t,T,i),n(t,d,i),n(t,F,i),n(t,p,i),u(p,w),u(w,j),Q($,j,null),u(p,yt),u(p,D),n(t,it,i),n(t,C,i),n(t,nt,i),n(t,m,i),u(m,g),u(g,U),Q(E,U,null),u(m,Tt),u(m,O),n(t,ot,i),n(t,b,i),n(t,at,i),n(t,P,i),n(t,rt,i),n(t,x,i),u(x,k),u(k,G),Q(L,G,null),u(x,$t),u(x,z),n(t,st,i),n(t,M,i),n(t,lt,i),n(t,N,i),n(t,ct,i),n(t,A,i),n(t,ut,i),n(t,q,i),n(t,ft,i),n(t,H,i),n(t,ht,i),n(t,v,i),u(v,_),u(_,J),Q(S,J,null),u(v,Ct),u(v,X),n(t,dt,i),n(t,R,i),n(t,pt,i),Q(y,t,i),n(t,mt,i),n(t,B,i),n(t,xt,i),n(t,W,i),vt=!0},p(t,[i]){const I={};i&2&&(I.$$scope={dirty:i,ctx:t}),y.$set(I)},i(t){vt||(V($.$$.fragment,t),V(E.$$.fragment,t),V(L.$$.fragment,t),V(S.$$.fragment,t),V(y.$$.fragment,t),vt=!0)},o(t){Z($.$$.fragment,t),Z(E.$$.fragment,t),Z(L.$$.fragment,t),Z(S.$$.fragment,t),Z(y.$$.fragment,t),vt=!1},d(t){t&&(e(T),e(d),e(F),e(p),e(it),e(C),e(nt),e(m),e(ot),e(b),e(at),e(P),e(rt),e(x),e(st),e(M),e(lt),e(N),e(ct),e(A),e(ut),e(q),e(ft),e(H),e(ht),e(v),e(dt),e(R),e(pt),e(mt),e(B),e(xt),e(W)),e(c),tt($),tt(E),tt(L),tt(S),tt(y,t)}}}const ne={local:"inferentia-exporter",sections:[{local:"export-functions",title:"Export functions"},{local:"configuration-classes-for-neuron-exports",title:"Configuration classes for Neuron exports"},{local:"supported-architectures",title:"Supported architectures"}],title:"Inferentia Exporter"};function oe(et){return Yt(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class ce extends Qt{constructor(c){super(),Vt(this,c,oe,ie,Wt,{})}}export{ce as component};
